#include <windows.h>
#include <cstdio>

using namespace std;

void TrazarTexto(int x, int y, const char *texto) {
    HANDLE hMutex;
    COORD dwPos = {x, y};

    hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, "MutexAccesoPantalla");

    if(WaitForSingleObject(hMutex, INFINITE) == WAIT_OBJECT_0){
        SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
        printf("%s", texto);
        ReleaseMutex(hMutex);
    }
    CloseHandle(hMutex);
}

class Hora {
    public:
        Hora(int xi, int yi) : x(xi), y(yi), seg(0) {
            manipulador =CreateThread( 0, 0, hiloMostrarHora, (void*)this, 0, 0);
            GetLocalTime(&st);
        }
        ~Hora() {
            WaitForSingleObject(manipulador, INFINITE);
            CloseHandle(manipulador);
        }
        void Terminar() { salir = true; }
    private:
        void Mostrar() const;
        void EsperarCambio();
        void ActualizarSeg();
        bool Salir() const { return salir; }
        SYSTEMTIME st;                    // Estructura para obtener la hora
        int x;
        int y;
        int seg;
        HANDLE manipulador;
        static bool salir;
        static DWORD WINAPI hiloMostrarHora( void* );
};

void Hora::Mostrar() const {
    char texto[9]; // Variable con el texto de la hora

    sprintf(texto, "%02d:%02d:%02d", st.wHour, st.wMinute, st.wSecond);
    TrazarTexto(x, y, texto);
}

void Hora::EsperarCambio() {
    while(seg == st.wSecond) {
        GetLocalTime(&st);
        Sleep(100);
    }
}

void Hora::ActualizarSeg() {
    seg = st.wSecond;
}

DWORD WINAPI Hora::hiloMostrarHora( void* par) {
    Hora *hora = (Hora*)par;  // Recuperar el parmetro, un puntero a Hora

    do {
        hora->EsperarCambio();
        hora->Mostrar();
        hora->ActualizarSeg();
    } while(!hora->Salir()); // Repetir hasta que salir sea true

    printf("Abandonando el hilo\n");
    return 0;
}

bool Hora::salir = false;

int main() {
    HANDLE hMutex = CreateMutex(NULL, FALSE, "MutexAccesoPantalla");

    Hora hora(70, 1);
    Hora hora2(1, 1);
    Hora hora3(70, 23);
    Hora hora4(1, 23);

    // Esperar a que el usuario pulse una tecla, el hilo se sigue ejecutando:
    TrazarTexto(4,10,"Pulsa una tecla para salir");
    getchar();
    hora.Terminar();

	// Liberar manipuladores:
    CloseHandle(hMutex);
    return 0;
}
